import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.math.BigInteger;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 04.11.2007
  * @author  claus albowski
  */

public class PotenzModuloDemo extends JFrame {
  // Anfang Variablen
  private JLabel jLabel1 = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private JLabel jLabel3 = new JLabel();
  private JLabel jLabel4 = new JLabel();
  private JTextField jTextField1 = new JTextField();
  private JTextField jTextField2 = new JTextField();
  private JTextField jTextField3 = new JTextField();
  private JTextField jTextField4 = new JTextField();
  private JButton jButton1 = new JButton();

  private JMenuBar jMenuBar = new JMenuBar();
  private JMenu jDateiMenu = new JMenu("Datei");
  private JMenuItem jDateiMenuItem1 = new JMenuItem("Ende");
  private JMenu jTestMenu = new JMenu("Test");
  private JMenuItem jTestMenuItem1 = new JMenuItem("einfache Werte encrypt");
  private JMenuItem jTestMenuItem2 = new JMenuItem("einfache Werte decrypt");

  private BigInteger basis;
  private BigInteger hochzahl;
  private BigInteger moduloZahl;
  private BigInteger ergebnis=BigInteger.ONE;
  private static BigInteger Big2 = new BigInteger("2");
  private JButton jButton2 = new JButton();
  // Ende Variablen

  private PotenzModuloDemo(String title) {
    // Frame-Initialisierung
    super(title);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) { System.exit(0); }
    });
    int frameWidth = 566;
    int frameHeight = 308;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2 ;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    jLabel1.setBounds(16, 8, 44, 16);
    jLabel1.setText("Basis");
    jLabel1.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel1);
    jTextField1.setBounds(16, 32, 529, 24);
    jTextField1.setText("12345");
    cp.add(jTextField1);

    jLabel2.setBounds(16, 64, 44, 16);
    jLabel2.setText("Hochzahl");
    jLabel2.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel2);
    jTextField2.setBounds(16, 88, 529, 24);
    jTextField2.setText("2560291");
    cp.add(jTextField2);
    
    jLabel3.setBounds(16, 120, 44, 16);
    jLabel3.setText("modulo");
    jLabel3.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel3);
    jTextField3.setBounds(16, 144, 529, 24);
    jTextField3.setText("1379303");
    cp.add(jTextField3);
    
    jLabel4.setBounds(152, 192, 244, 16);
    jLabel4.setText("(Zwischen-)Ergebnis");
    jLabel4.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabel4);
    jTextField4.setBounds(16, 216, 529, 24);
    jTextField4.setText("");
    cp.add(jTextField4);

    jButton1.setBounds(16, 184, 123, 25);
    jButton1.setText("Schritt");
    cp.add(jButton1);
    jButton1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton1ActionPerformed(evt);
      }
    });

    jButton2.setBounds(424, 184, 115, 25);
    jButton2.setText("Ende");
    cp.add(jButton2);
    jButton2.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton2ActionPerformed(evt);
      }
    });

    setJMenuBar(jMenuBar);

    jMenuBar.add(jDateiMenu);
    jDateiMenuItem1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jDateiMenuItem1ActionPerformed(evt); } });
    jDateiMenu.add(jDateiMenuItem1);

    jMenuBar.add(jTestMenu);
    jTestMenuItem1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jTestMenuItem1ActionPerformed(evt); } });
    jTestMenu.add(jTestMenuItem1);

    jTestMenuItem2.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jTestMenuItem2ActionPerformed(evt); } });
    jTestMenu.add(jTestMenuItem2);

    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  }

  // Anfang Ereignisprozeduren
  public void jButton1ActionPerformed(ActionEvent evt) {
      basis = new BigInteger(jTextField1.getText());
      hochzahl = new BigInteger(jTextField2.getText());
      moduloZahl = new BigInteger(jTextField3.getText());
      Potenzmodulo();
      jTextField1.setText(basis.toString());
      jTextField2.setText(hochzahl.toString());
      jTextField3.setText(moduloZahl.toString());
      jTextField4.setText(ergebnis.toString());
  }

  public void jButton2ActionPerformed(ActionEvent evt) {
      System.exit(0); 
  }

  public void jDateiMenuItem1ActionPerformed(ActionEvent evt) {
      System.exit(0); 
  }
  public void jTestMenuItem1ActionPerformed(ActionEvent evt) {
      jTextField1.setText("12345");
      jTextField2.setText("2560291");
      jTextField3.setText("1379303");
      jTextField4.setText("1");
      ergebnis=BigInteger.ONE;
  }
  public void jTestMenuItem2ActionPerformed(ActionEvent evt) {
      jTextField1.setText(ergebnis.toString());
      jTextField2.setText("1209739");
      jTextField3.setText("1379303");
      jTextField4.setText("1");
      ergebnis=BigInteger.ONE;
  }
  // Ende Ereignisprozeduren

  /**
     * ein Schritt der Potenzmodulo - Funktion.
     */
    public void Potenzmodulo(){
        if (!hochzahl.equals(BigInteger.ZERO)) 
        if (hochzahl.equals(BigInteger.ONE)) {
            ergebnis=ergebnis.multiply(basis).mod(moduloZahl);
            hochzahl=BigInteger.ZERO;
        }
        else {
            if (hochzahl.mod(Big2).equals(BigInteger.ONE))
            ergebnis=ergebnis.multiply(basis).mod(moduloZahl);
            basis=basis.multiply(basis).mod(moduloZahl);
            hochzahl=hochzahl.divide(Big2);
        }
    }
//    /**
//     * setzt kleine Werte fuer eine Beispielrechnung.
//     */
//    public void setzeKleineWerte(){
//       bitLength=11;
//       p = new BigInteger("1009");
//       q = new BigInteger("1367");
//       n = new BigInteger("1379303");
//       phi = new BigInteger("1376928");
//       e = new BigInteger("2560291");
//       d =  new BigInteger("1209739");
//    }
//
  public static void main(String[] args) {
    new PotenzModuloDemo("PotenzModuloDemo");
  }
}

